!cpu 6510
get         = $0a
put         = $0c
; ______________________________________________________________________
; ______________________________________________ INCLUDES
!source"../../bin/framework/frameworksymbols.inc"

!if RELEASE = 0 {
  *= $0400
    !bin "../../bin/framework/framework-noloader.prg",,2

  *= fw_music_init
    !bin "../framework/music/dt2remix-part-03.sid",,$7e
}
; ______________________________________________________________________

screen              = $0400
d016_value          = $0a

*= $1ffe
  !byte <code_start
  !byte >code_start

*= $2000
; ______________________________________________________________________
; ______________________________________________ CODE START
code_start:
  lda #%00000011
  sta $dd00

  ;lda #%10000100‬; screen $2000 char $1000
  lda #%00010100 ; screen $0400 char $1000
  sta $d018

  lda #$00
  sta fw_color_d020
  sta fw_color_d021

  lda #%00001000
  sta $d016

  lda #$20
  jsr fill_screen_with_a

  lda #$0f
  jsr fill_screencolor_with_a

  lda #$00
  sta fw_irq_ready
-
  lda fw_irq_ready
  beq -

  lda #%0011011
  sta fw_d011_value

  lda #line_end_screen
  sta fw_d012_value

  lda #<irq_end_screen
  sta fw_irq_lo
  lda #>irq_end_screen
  sta fw_irq_hi

loop:
  lda workerflag
;---------------------------------------
  cmp #$01
  bne +

  jsr decompress_monolith_bwd

  lda #$00
  sta workerflag
  jmp exit_workerphase
+
;---------------------------------------
  cmp #$02
  bne +

  jsr decompress_monolith_fwd

  lda #$00
  sta workerflag
  jmp exit_workerphase
+
;---------------------------------------
  cmp #$03
  bne +

  lda #$20
  jsr fill_screen_with_a

  lda #$00
  sta workerflag
  jmp exit_workerphase
+
;---------------------------------------
  cmp #$04
  bne +
exit_part:
    jsr fw_wait_irq

    lda #<fw_irq
    sta $fffe
    sta fw_irq_lo
    lda #>fw_irq
    sta $ffff
    sta fw_irq_hi

    lda #$00
    sta $d012
    sta fw_d012_value
    sta fw_color_d020
    sta fw_color_d021

    lda #$0b
    sta $d011
    sta fw_d011_value
!if RELEASE = 0 {
    jmp *
} else {
    jmp fw_back2framework
}
+
;---------------------------------------
exit_workerphase:
  jmp loop

workerflag:
  !byte $00

!source "irqs.asm"
!source "screen.asm"
!source "animate.asm"
!source "animate_monolith.asm"
!source "de-rle.asm"
!source "fade_to_grey.asm"
!source "fade_screen000.asm"
!source "fade_screen001.asm"
!source "fade_screen002.asm"
!source "fade_screen003.asm"
!source "fade_screen004.asm"
!source "fade_screen005.asm"
!source "fade_screen006.asm"
!source "fade_screen007.asm"
!source "fade_screen008.asm"

animate_monolith000:
!bin "bin/zoom_in-screendata000.bin.rle",,
animate_monolith001:
!bin "bin/zoom_in-screendata001.bin.rle",,
animate_monolith002:
!bin "bin/zoom_in-screendata002.bin.rle",,
animate_monolith003:
!bin "bin/zoom_in-screendata003.bin.rle",,
animate_monolith004:
!bin "bin/zoom_in-screendata004.bin.rle",,
animate_monolith005:
!bin "bin/zoom_in-screendata005.bin.rle",,
animate_monolith006:
!bin "bin/zoom_in-screendata006.bin.rle",,
animate_monolith007:
!bin "bin/zoom_in-screendata007.bin.rle",,
animate_monolith008:
!bin "bin/zoom_in-screendata008.bin.rle",,
animate_monolith009:
!bin "bin/zoom_in-screendata009.bin.rle",,
animate_monolith010:
!bin "bin/zoom_in-screendata010.bin.rle",,
animate_monolith011:
!bin "bin/zoom_in-screendata011.bin.rle",,
animate_monolith012:
!bin "bin/zoom_in-screendata012.bin.rle",,
animate_monolith013:
!bin "bin/zoom_in-screendata013.bin.rle",,
animate_monolith014:
!bin "bin/zoom_in-screendata014.bin.rle",,
animate_monolith015:
!bin "bin/zoom_in-screendata015.bin.rle",,
animate_monolith016:
!bin "bin/zoom_in-screendata016.bin.rle",,
animate_monolith017:
!bin "bin/zoom_in-screendata017.bin.rle",,
animate_monolith018:
!bin "bin/zoom_in-screendata018.bin.rle",,
animate_monolith019:
!bin "bin/zoom_in-screendata019.bin.rle",,
animate_monolith020:
!bin "bin/zoom_in-screendata020.bin.rle",,
animate_monolith021:
!bin "bin/zoom_in-screendata021.bin.rle",,
animate_monolith022:
!bin "bin/zoom_in-screendata022.bin.rle",,
animate_monolith023:
!bin "bin/zoom_in-screendata023.bin.rle",,
animate_monolith024:
!bin "bin/zoom_in-screendata024.bin.rle",,
animate_monolith025:
!bin "bin/zoom_in-screendata025.bin.rle",,
animate_monolith026:
!bin "bin/zoom_in-screendata026.bin.rle",,
