!zone fade_end
animate_end:
  jsr rotate
  jsr .fade_end
  rts

.fade_end:  
  lda .phase
;-------------------------------------------------------- fade in star in 90 degree = rectangle
  cmp #$00
  bne ++
  jsr fade_start_fade
  jsr fade_start_fade
  lda fade_start_isready
  clc
  adc .phase
  sta .phase

  lda fade_start_modvalue2+2
  cmp #$db
  bne +
  lda fade_start_modvalue2+1
  cmp #$5c
  bne +
  lda #$03
  sta rotate_half_rotations_to_do                       ; start rotation
  inc .phase
+    
  jmp .exit_phase_find   
++
;-------------------------------------------------------- pause fade (but not rotate)
  cmp #$01
  bne ++
  dec .wait
  bne +
  lda .default_wait_time
  sta .wait
  inc .phase   
+    
  jmp .exit_phase_find   
++
;-------------------------------------------------------- fade in G*P
  cmp #$02
  bne ++
  jsr fade_start_fade
  jsr fade_start_fade
  lda fade_start_isready
  clc
  adc .phase
  sta .phase
  jmp .exit_phase_find  
++
;-------------------------------------------------------- start cleaning 
  cmp #$03
  bne ++
  jsr fade_start_set_clear_animation
  inc .phase   
  jmp .exit_phase_find
++  
;-------------------------------------------------------- pause fade
  cmp #$04
  bne ++
  dec .wait
  bne +
  lda .default_wait_time
  sta .wait
  inc .phase
  lda #$02
  sta rotate_half_rotations_to_do                       ; start rotation
+    
  jmp .exit_phase_find   
++
;-------------------------------------------------------- fade out G P
  cmp #$05
  bne ++
  jsr fade_start_fade
  jsr fade_start_fade

  ; delete reflections first
  lda #$00
  sta $d800 + 237
  sta $d800 + 238
  sta $d800 + 250
  sta $d800 + 445
  sta $d800 + 446
  sta $d800 + 485
  sta $d800 + 589
  sta $d800 + 602
  sta $d800 + 629
    
  lda fade_start_isready
  clc
  adc .phase
  sta .phase
  jmp .exit_phase_find    
++
;-------------------------------------------------------- fade in HIT
  cmp #$06
  bne ++
  jsr fade_hitmen_fade
  jsr fade_hitmen_fade
  jsr fade_hitmen_fade
  lda fade_hitmen_isready
  clc
  adc .phase
  sta .phase
  jmp .exit_phase_find    
++
;-------------------------------------------------------- start cleaning -> short pause/copyjob in mainloop
  cmp #$07
  bne ++
  dec .wait
  bne +
  lda .default_wait_time
  sta .wait  
  jsr fade_hitmen_set_clear_animation
  inc .phase
+
  jmp .exit_phase_find
++  
;-------------------------------------------------------- fade out HIT
  cmp #$08
  bne ++
  jsr fade_hitmen_fade
  jsr fade_hitmen_fade
  jsr fade_hitmen_fade
  jsr fade_hitmen_fade
  jsr fade_hitmen_fade
  lda fade_hitmen_isready
  clc
  adc .phase
  sta .phase
  jmp .exit_phase_find
++    
;-------------------------------------------------------- exit animation  
  cmp #$09
  bne ++
  inc animation_phase   
  jmp .exit_phase_find
++  
.exit_phase_find:  
  rts

.default_wait_time:
  !byte $4e
.wait:
  !byte $4e
.phase:
  !byte $00 

fade_end_reset
  lda #$4e
  sta .default_wait_time:
  lda #$4e
  sta .wait:
  lda #$00
  sta .phase:
  rts

!zone rotate  
rotate:
  dec .wait
  bne .wait_longer
  lda #$02
  sta .wait

  lda rotate_half_rotations_to_do
  cmp #$00
  beq .wait_longer

  inc .phase
  lda .phase
  cmp #$05
  bne +
  ldy #$12
  sty .wait
  dec rotate_half_rotations_to_do 
+ cmp #$0a
  bne +
  lda #$00
  sta .phase  

+ 
  tay
  lda .jumptable_high,y
  sta .jump_position+1

  lda .jumptable_low,y
  sta .jump_position+2

.jump_position:
  jsr $0000
  
.wait_longer:  
  rts
.wait:
  !byte $03
.phase:
  !byte $09  
rotate_half_rotations_to_do:
  !byte $00

rotate_reset:
  lda #$03
  sta .wait
  lda #$09
  sta .phase
  lda #$00
  sta rotate_half_rotations_to_do
  rts

.jumptable_high:
  !byte <patch_screen_000, <patch_screen_001, <patch_screen_002, <patch_screen_003, <patch_screen_004 
  !byte <patch_screen_005, <patch_screen_006, <patch_screen_007, <patch_screen_008, <patch_screen_009
.jumptable_low:
  !byte >patch_screen_000, >patch_screen_001, >patch_screen_002, >patch_screen_003, >patch_screen_004 
  !byte >patch_screen_005, >patch_screen_006, >patch_screen_007, >patch_screen_008, >patch_screen_009    
  