!cpu 6510

; ______________________________________________________________________
; ______________________________________________ INCLUDES
!source "../../bin/framework/frameworksymbols.inc"

!if RELEASE = 0 {
  *= $0400
    !bin "../../bin/framework/framework-noloader.prg",,2

  *= fw_music_init
    !bin "../framework/music/dt2remix-part-03.sid",,$7e
}
; ______________________________________________________________________

screen = $0400

*= $1ffe
  !byte <code_start
  !byte >code_start

*= $2000
; ______________________________________________________________________
; ______________________________________________ CODE START
code_start:
  lda #%00000011
  sta $dd00

  ;lda #%10000100‬; screen $2000 char $1000
  lda #%00010100 ; screen $0400 char $1000
  sta $d018

  lda #%00001000
  sta $d016

  lda #$00
  sta fw_color_d020
  sta fw_color_d021

  jsr fill_demo_end

  lda #$02
  sta workerflag

  lda #$00
  sta fw_irq_ready
-
  lda fw_irq_ready
  beq -

  lda d011_value
  sta fw_d011_value

  lda #line_after_screen
  sta fw_d012_value

  lda #<irq_after_screen
  sta fw_irq_lo
  lda #>irq_after_screen
  sta fw_irq_hi

loop:
  lda workerflag
; put all stuff in this workerpart that needs
; more time than the next rasterpart
; so it is some kind of "async"
;---------------------------------------
  cmp #$01
  bne +
  jsr screencopy_speedcode ;scroll up one screen witch color
  jsr copy_screen_and_colorline
  lda #$00
  sta workerflag
  jmp exit_workerphase
+
;---------------------------------------
  cmp #$02
  bne +
  jsr screencopy_speedcode_generator ;generate speedcode
  lda #$00
  sta workerflag
  jmp exit_workerphase
+
;---------------------------------------
  cmp #$03
  bne +
  jsr decompress ;RLE decode explosion
  lda #$00
  sta workerflag
  jmp exit_workerphase
+
;---------------------------------------
  cmp #$04
  bne +

exit_part:
    jsr fw_wait_irq

    lda #<fw_irq
    sta $fffe
    sta fw_irq_lo
    lda #>fw_irq
    sta $ffff
    sta fw_irq_hi

    lda #$00
    sta $d012
    sta fw_d012_value

    lda #$0b
    sta $d011
    sta fw_d011_value
!if RELEASE = 0 {
    jmp exit_reset
} else {
    jmp fw_back2framework
}
exit_reset:
  jsr reset_part ;reset part
  jsr decompress ;RLE decode explosion
  lda #$00
  sta workerflag
  jmp exit_workerphase
+
;---------------------------------------
  cmp #$05
  bne +
  jsr reset_part ;reset part
  ;jsr decompress ;RLE decode explosion
  lda #$00
  sta workerflag
  jmp exit_workerphase
+
;---------------------------------------
exit_workerphase:
  jmp loop

workerflag:
  !byte $00

fill_demo_end:
    lda #$20
    ldx #$fa
-
    sta demo_end+(0*$fa)-1,x
    sta demo_end+(1*$fa)-1,x
    sta demo_end+(2*$fa)-1,x
    sta demo_end+(3*$fa)-1,x
    dex
    bne -
    rts

!source "irqs.asm"
!source "star_animation_speedcode.asm"
!source "fade_start.asm"
!source "fade_hitmen.asm"
!source "animate_end.asm"
!source "animate_scroller.asm"
!source "screencopy_speed_gen.asm"
!source "keypress.asm"
!source "de-rle.asm"
!source "animate_our_stars.asm"
!source "reset_part.asm"
!source "start_fade_in.asm"

colormem_start:
!bin "bin/02-our-stars-colormap-colordata000.NIB"
anim_our_stars000:
!bin "bin/03-our-stars-screendata000.bin.cut.rle"
anim_our_stars001:
!bin "bin/03-our-stars-screendata001.bin.cut.rle"
anim_our_stars002:
!bin "bin/03-our-stars-screendata002.bin.cut.rle"
anim_our_stars003:
!bin "bin/03-our-stars-screendata003.bin.cut.rle"
anim_our_stars004:
!bin "bin/03-our-stars-screendata004.bin.cut.rle"
anim_our_stars005:
!bin "bin/03-our-stars-screendata005.bin.cut.rle"
anim_our_stars006:
!bin "bin/03-our-stars-screendata006.bin.cut.rle"
anim_our_stars007:
!bin "bin/03-our-stars-screendata007.bin.cut.rle"
anim_our_stars008:
!bin "bin/03-our-stars-screendata008.bin.cut.rle"
anim_our_stars009:
!bin "bin/03-our-stars-screendata009.bin.cut.rle"
anim_our_stars010:
!bin "bin/03-our-stars-screendata010.bin.cut.rle"
anim_our_stars011:
!bin "bin/03-our-stars-screendata011.bin.cut.rle"
anim_our_stars012:
!bin "bin/03-our-stars-screendata012.bin.cut.rle"
anim_our_stars013:
!bin "bin/03-our-stars-screendata013.bin.cut.rle"
anim_our_stars014:
!bin "bin/03-our-stars-screendata014.bin.cut.rle"
anim_our_stars015:
!bin "bin/03-our-stars-screendata015.bin.cut.rle"
anim_our_stars016:
!bin "bin/03-our-stars-screendata016.bin.cut.rle"
anim_our_stars017:
!bin "bin/03-our-stars-screendata017.bin.cut.rle"
anim_our_stars018:
!bin "bin/03-our-stars-screendata018.bin.cut.rle"
anim_our_stars019:
!bin "bin/03-our-stars-screendata019.bin.cut.rle"

colormem_mega_scroller:
!bin "bin/26-complete-colordata000.NIB"
!bin "bin/26-complete-colordata001.NIB"
!bin "bin/26-complete-colordata002.NIB"
!bin "bin/26-complete-colordata003.NIB"
!bin "bin/26-complete-colordata004.NIB"
!bin "bin/26-complete-colordata005.NIB"
!bin "bin/26-complete-colordata006.NIB"
!bin "bin/26-complete-colordata007.NIB"
!bin "bin/26-complete-colordata008.NIB"
!bin "bin/26-complete-colordata009.NIB"
!bin "bin/26-complete-colordata010.NIB"
!bin "bin/26-complete-colordata011.NIB"
!bin "bin/26-complete-colordata012.NIB"
!bin "bin/26-complete-colordata013.NIB",(20*20),
colormem1:
!bin "bin/13-hitmen_genesis-colordata001.NIB" ; this one is the colormap of the the GP/Hitman star

screenmem_mega_scroller:
!bin "bin/26-complete-screendata000.bin"
!bin "bin/26-complete-screendata001.bin"
!bin "bin/26-complete-screendata002.bin"
!bin "bin/26-complete-screendata003.bin"
!bin "bin/26-complete-screendata004.bin"
!bin "bin/26-complete-screendata005.bin"
!bin "bin/26-complete-screendata006.bin"
!bin "bin/26-complete-screendata007.bin"
!bin "bin/26-complete-screendata008.bin"
!bin "bin/26-complete-screendata009.bin"
!bin "bin/26-complete-screendata010.bin"
!bin "bin/26-complete-screendata011.bin"
!bin "bin/26-complete-screendata012.bin"
!bin "bin/26-complete-screendata013.bin",(40*20),

; !! WARNING don't put code beyond this line !!
; !! 1000 bytes will be overwritten by       !!
; !! fill_demo_end                           !!
demo_end:; the screen of the GP/Hitman star starts with black, so we can fade in the chars
screenmem_mega_scroller_end = *+1000

