!zone screencopy_speedcode_generator
  
.speedcode_start1      = $C000
.speedcode_start2      = $E000

LDA_MNEMONIC           = $ad
STA_MNEMONIC           = $8d
RTS_MNEMONIC           = $60

; Create speedcode for screencopy upwards
;
;  LDA $screen+40
;  STA $screen
;  LDA $color+40
;  STA $color

screencopy_speedcode:
          jsr .speedcode_start1
          jsr .speedcode_start2
          rts
          
screencopy_speedcode_generator:
          jsr .initialize1
          jsr .initialize2
          rts
          
.initialize1:
;Initialize
          lda #<.speedcode_start1
          sta .speedcode_address+1
          lda #>.speedcode_start1
          sta .speedcode_address+2   

          lda #<$D800
          sta .color_address_old
          lda #>$D800
          sta .color_address_old+1   
          
          lda #<screen
          sta .screen_address_old
          lda #>screen
          sta .screen_address_old+1             
          
          lda #<($D800+40)
          sta .color_address
          lda #>($D800+40)
          sta .color_address+1   
          
          lda #<(screen+40)
          sta .screen_address
          lda #>(screen+40)
          sta .screen_address+1             

          jsr .generate_speedcode          
          
;Generate RTS
          lda #RTS_MNEMONIC
          jsr .STA_and_INC_speedcode_address

          rts

.initialize2:
          lda #<.speedcode_start2
          sta .speedcode_address+1
          lda #>.speedcode_start2
          sta .speedcode_address+2   

          lda #$10
          sta .linevalue+1
          jsr .generate_speedcode          
          
;Generate RTS
          lda #RTS_MNEMONIC
          jsr .STA_and_INC_speedcode_address

          rts

.generate_speedcode:
          ldy #$00
--        ldx #$00
-         
;Generate LDA $(COLOR_MEM+40)
          lda #LDA_MNEMONIC
          jsr .STA_and_INC_speedcode_address

          lda .color_address
          jsr .STA_and_INC_speedcode_address 

          lda .color_address+1
          jsr .STA_and_INC_speedcode_address

;Generate STA $COLOR_MEM
          lda #STA_MNEMONIC
          jsr .STA_and_INC_speedcode_address

          lda .color_address_old
          jsr .STA_and_INC_speedcode_address

          lda .color_address_old+1
          jsr .STA_and_INC_speedcode_address

;Generate LDA $(SCREEN_MEM+40)
          lda #LDA_MNEMONIC
          jsr .speedcode_address 
          

          lda .screen_address
          jsr .STA_and_INC_speedcode_address

          lda .screen_address+1
          jsr .STA_and_INC_speedcode_address

;Generate STA $SCREEN_MEM
          lda #STA_MNEMONIC
          jsr .STA_and_INC_speedcode_address

          lda .screen_address_old
          jsr .STA_and_INC_speedcode_address

          lda .screen_address_old+1
          jsr .STA_and_INC_speedcode_address
          
          jsr .inc_screen_address
          jsr .inc_color_address
          
          inx
          cpx #$28 ;40 chars
          bne -
          iny
          ; do the first lines with initialize1
          ; modify and do last lines with initialize2
.linevalue          
          cpy #$08 ;#$17 = 24 lines
          bne --
          
          rts
          
.STA_and_INC_speedcode_address:
.speedcode_address:          
          sta $0000
          inc .speedcode_address+1
          bne +
          inc .speedcode_address+2
+         
          rts
          
.inc_screen_address:
          inc .screen_address
          bne +
          inc .screen_address+1
+
          inc .screen_address_old
          bne +
          inc .screen_address_old+1
+          
          rts

.inc_color_address:
          inc .color_address
          bne +
          inc .color_address+1
+
          inc .color_address_old
          bne +
          inc .color_address_old+1
+          
          rts
          
.screen_address_old:         
         !byte $00, $00
.screen_address:         
         !byte $00, $00
         
.color_address_old:         
         !byte $00, $00
.color_address:         
         !byte $00, $00
