!cpu 6510

DEBUG = 0

; SYNCVAL: no. of frames (-1) the spock animation is delayed at the end
SYNCVAL         = $4
LASTPTRN        = $71
music_patternpt = fw_music_init+$036e
; ______________________________________________________________________

scr0          = $4000
spr0          = scr0+$03f8
scr1          = $4400
spr1          = scr1+$03f8
scr2          = $4800
spr2          = scr2+$03f8
scr3          = $4c00
spr3          = scr3+$03f8

charset       = $5000

col           = $d800
zp1           = $a6 ; / $a7
zp2           = $a8 ; / $a9

zp_temp0      = $05 ; / $06
zp_temp1      = $07 ; / $08
zp_temp2      = $09 ; / $0a
zp_temp3      = $0b ; / $0c

irq_bottom_ready = $10

text_pt       = $aa
text_pt_lo    = text_pt
text_pt_hi    = text_pt+1

vic           = $d000
spockscreen   = $0400

field1        = $6000
field1_speed  = field1+$ce
field2        = $7900
field2_speed  = field2+$ce
field3        = $9200
field3_speed  = field3+$ce
field4        = $ab00
field4_speed  = field4+$ce

irq1_line     = $8a
; ______________________________________________________________________
; ______________________________________________ INCLUDES
!src "../../bin/framework/frameworksymbols.inc"

!if RELEASE = 0 {
    *= $0400
      !bin "../../bin/framework/framework-noloader.prg",,2

    *= fw_music_init
      !bin "../framework/music/dt2remix-part-01.sid",,$7e
}

*= $5800; SPRITEFONT
    !bin "maydaystarfieldalphabet-roly.spd",,3
; ______________________________________________________________________

*= $1ffe
    !byte <code_start
    !byte >code_start

; ______________________________________________________________________
*= $2000
code_start:
    lda #$00
    sta irq_bottom_ready
    tax
-
    sta col,x
    sta col+$100,x
    sta col+$200,x
    sta col+$2e8,x
    inx
    bne -
-
    lda spockdata,x
    sta spockscreen,x
    lda spockdata+$100,x
    sta spockscreen+$100,x
    lda spockdata+$200,x
    sta spockscreen+$200,x
    lda spockdata+$2e8,x
    sta spockscreen+$2e8,x
    inx
    bne -

    ldy #$00
    lda #$ff
targetzerofill	; zerofill charset
-	  sta charset,x
    inx
    bne -
    inc targetzerofill+2
    iny
    cpy #08
    bne -

    lda #$1b
    sta $d011
    sta fw_d011_value
    lda #$08
    sta $d016
    lda #$15
    sta $d018
    lda #$03
    sta $dd00

    ldy #00
  ;generatestarchars; 64 1x1 pixel chars
setvalhi
--	ldx #(>charset)
    stx zp1+1
setvallo
    ldx #$00
    stx zp1
    ldx #$00
charval
-	  lda #$80
    eor #$ff
    sta (zp1),y
    lda zp1
    clc
    adc #65
    bcc +
    inc zp1+1
+	  sta zp1
    inx
    cpx #8
    bne -
    lda charval+1
    lsr
    sta charval+1
    lda setvallo+1
    clc
    adc #08
+	  sta setvallo+1
    bne --

;generatestarchars; 64 1x1 pixel chars
bigstars_setvalhi
--	ldx #(>(charset+$200))
    stx zp1+1
bigstars_setvallo
    ldx #$00
    stx zp1
    ldx #$00
bigstars_charval
-	  lda #$c0
    eor #$ff
    ldy #$00
    sta (zp1),y
    iny
    sta (zp1),y
    lda zp1
    clc
    adc #34
    bcc +
    inc zp1+1
+	  sta zp1
    inx
    cpx #4
    bne -
    lda bigstars_charval+1
    lsr
    lsr
    sta bigstars_charval+1
    lda bigstars_setvallo+1
    clc
    adc #08
+	  sta bigstars_setvallo+1
    bne --

    tax
-	  jsr random
    sta field,x
    inx
    bne -

-
    lda field,x
    sta scr0,x
    sta scr0+$100,x
    sta scr0+$200,x
    sta scr0+$2e7,x
    sta scr1,x
    sta scr1+$100,x
    sta scr1+$200,x
    sta scr1+$2e7,x
    sta scr2,x
    sta scr2+$100,x
    sta scr2+$200,x
    sta scr2+$2e7,x
    sta scr3,x
    sta scr3+$100,x
    sta scr3+$200,x
    sta scr3+$2e7,x
    lda #$00
    sta col,x
    sta col+$100,x
    sta col+$200,x
    sta col+$2e8,x
    inx
    bne -

    jsr generate_code

init_irq:
    lda #<irq0
    sta fw_irq_lo
    lda #>irq0
    sta fw_irq_hi

    lda #$1b
    sta fw_d012_value

    lda #$1b
    sta fw_d011_value

    lda #$02
    sta $dd00

    lda #$04
    sta $d018

    lda #$c0
    sta $d016

    lda #$0f
    sta fw_color_d021
; ______________________________________________________________________
mainloop:
    jsr fw_wait_irq

textpointer:
    ldy #$00
    cpy #190
    bne +
    lda #$ff
    ldx #7
-
    sta charset,x
    dex
    bpl -
    jmp fade_out_enter
+

    jsr wait_irq_bottom

!if DEBUG = 1 {
    dec $d020
}
jsr_mod = *+2
    jsr field1
!if DEBUG = 1 {
    inc $d020
}

    jmp mainloop

; ______________________________________________________________________
random:
    lda #$00      ; generate random number from 0-255
    eor $dc04
    eor $dc05
    eor $dd04
    adc $dd05
    eor $dd06
    eor $dd07
    sta random+1
    rts
; ______________________________________________________________________
setsprites:
    lda #$00
    sta subtracting+1
    lda text,y
    sta yposlogo+1
    lda #<xposlogo+10
    sta whichaddress+1
    lda #>xposlogo+10
    sta whichaddress+2
    ldx #$00
-	  iny
    tya
    pha
    lda text,y
    pha
    tay
    lda distance,y
whichaddress:
    sta xposlogo+10
    clc
    adc subtracting+1
    sta subtracting+1
    pla
    and #%00011111
    clc
    adc #$60
    sta spr0,x
    sta spr1,x
    sta spr2,x
    sta spr3,x

    lda whichaddress+1
    clc
    adc #6
    bcc +
    inc whichaddress+2
+	  sta whichaddress+1
    pla
    tay
    inx
    cpx #8
    bne -


; routine to x-center text
    lda #224
    sec
subtracting:
    sbc #00
    lsr
    sta additionalbytes+1

    lda #$ff
    sta vic+23; y-stretch
    sta vic+28; multicolor
    sta vic+21
logocolor:
    lda #$0f
    bne +
    inc vic+21
+	  sta vic+37; mc 1
    lda #$00
    sta vic+38; mc 2
    sta vic+29; x-stretch

yposlogo:
    ldy #$80
    sty vic+1
    sty vic+3
    sty vic+5
    sty vic+7
    sty vic+9
    sty vic+11
    sty vic+13
    sty vic+15

xposlogo:
    lda #74
    clc
additionalbytes:
    adc #00
    sta vic
    clc
    adc #28
    sta vic+2
    clc
    adc #28
    sta vic+4
    clc
    adc #28
    sta vic+6
    clc
    adc #28
    sta vic+8
    clc
    adc #28
    sta vic+10
    clc
    adc #28
    sta vic+12
    clc
    adc #28
    sta vic+14
    clc
    adc #28
    lda #%10000000
    sta vic+$10
    rts
; ______________________________________________________________________
blinking:
    dec .colcounter+1

.colcounter:
    ldx #$0a
    bne ++
    lda #$0a
    sta .colcounter+1
.colpointer:
    ldx #$00
    lda coltab,x
    sta logocolor+1
    cmp #$0f
    bne +
    dec repetitions+1
    ldx #$ff
+	  inx
    stx .colpointer+1
++
    rts
; ______________________________________________________________________
!zone FADE_OUT
fade_out:
    jsr fw_wait_irq

    lda #$ff
    sta repetitions+1

    jsr .clear_field
fade_out_enter:
    lda #$3a
    cmp $d012
    bcs *-3

!if DEBUG = 1 {
    dec $d020
}
jsr_mod1 = *+2
    jsr field1
!if DEBUG = 1 {
    inc $d020
}
    jsr .clear_sprites
    lda .clear_sprites
    cmp #$60
    bne +
    lda fw_global_ct
    cmp #$6f
    bne +
    jmp exit_part
+
    jmp fade_out

.clear_field:
    nop
.xsav =*+1
    ldx #0

    lda #0
    sta field,x
    inx
    bne +
    lda #$60
    sta .clear_field
+
    stx .xsav
    rts

.clear_sprites:
    nop
.ct0 = *+1
    lda #$ff
    beq +
    dec .ct0
    rts
+
    lda #$17
    sta .ct0

    lda #$00

.pt1 =*+1
    ldx #0
    sta text_fallen,x
    sta text_stars,x
    inx
    cpx #8
    bne +
    lda #$60
    sta .clear_sprites
+
    stx .pt1
    rts
exit_part:
    lda #0
    sta fw_color_d021

    jsr fw_wait_irq

    lda #<fw_irq
    sta $fffe
    sta fw_irq_lo
    lda #>fw_irq
    sta $ffff
    sta fw_irq_hi

    lda #$00
    sta $d012
    sta fw_d012_value

    lda #$15
    sta $d018

    lda #$03
    sta $dd00

    lda #$00
    sta $d015

    lda #$c8
    sta $d016

    ldy #00
--	ldx #10
-	  jsr fw_wait_irq
    dex
    bne -
    lda coltab-1,y
    sta fw_color_d021
    iny
    cpy #5
    bne --

writespock: ; writes the text in the spock PETSCII screen
    ldx #00
    lda spocktexttab,x
    tay
    inx
    lda spocktexttab,x
    sta writespocktarget+1
    inx
    lda spocktexttab,x
    sta writespocktarget+2
    ldx #$00
-
    jsr fw_wait_irq
    dec writedelay+1
writedelay
    lda #3
    bne -
    lda #3
    sta writedelay+1
writespocksource
    lda spocktext
writespocktarget
    sta $0400,x
    inx
    inc writespocksource+1
    bne +
    inc writespocksource+2
+	  dey
    bne -
    lda writespock+1
    clc
    adc #3
    cmp #36
    beq ++
writephrases
    cmp #9
    bne +
    pha
    ldx #37
-	  jsr fw_wait_irq
    dex
    bne -
    lda writephrases+1
    clc
    adc #9
    sta writephrases+1
    pla
+	  sta writespock+1
    jmp writespock

++
-   lda music_patternpt
    cmp #LASTPTRN
    bne -

    ldy #SYNCVAL
-   jsr fw_wait_irq
    dey
    bne -

    jsr spockanim
-
    lda fw_global_ct
    cmp #$17
    bne -
    lda fw_global_ct+1
    cmp #$3d
    bne -
    lda #$2c
    sta fw_irq+16
    jmp *
; ______________________________________________________________________
wait_irq_bottom:
    lda #0
    sta irq_bottom_ready
-
    lda irq_bottom_ready
    beq -
    rts
; ______________________________________________________________________
spockanim:
    lda #$20
    sta spockscreen+$0083
    sta spockscreen+$00d4
    sta spockscreen+$00d5
    lda #$22
    sta spockscreen+$0128
    lda #$27
    sta spockscreen+$0154
    lda #$2b
    sta spockscreen+$0124
    lda #$2c
    sta spockscreen+$02e6
    lda #$2d
    sta spockscreen+$030d
    lda #$2e
    sta spockscreen+$010a
    lda #$2f
    sta spockscreen+$012d
    lda #$62
    sta spockscreen+$00fe
    sta spockscreen+$0107
    lda #$64
    sta spockscreen+$0084
    lda #$6c
    sta spockscreen+$00fd
    lda #$6f
    sta spockscreen+$0085
    sta spockscreen+$00ff
    lda #$77
    sta spockscreen+$00d3
    lda #$78
    sta spockscreen+$00d6
    lda #$7f
    sta spockscreen+$0101
    lda #$a0
    sta spockscreen+$00ae
    lda #$e4
    sta spockscreen+$00ad
    sta spockscreen+$00d7
    lda #$e9
    sta spockscreen+$00ab
    lda #$f8
    sta spockscreen+$00af
    lda #$f9
    sta spockscreen+$00ac
    lda #$fb
    sta spockscreen+$0100
    lda #$fc
    sta spockscreen+$00d8
    rts
; ______________________________________________________________________
!zone GENERATOR
generate_code:
    ldx #0
-
    lda field1,x
    sta field2,x
    sta field3,x
    sta field4,x
    inx
    cpx #$ce
    bne -

    ldy #<(.offset_table_end-.offset_table-1)
-
    lda .offset_table,y
    tax
    lda field1,x
    eor #$04
    sta field2,x
    eor #$0c
    sta field3,x
    eor #$04
    sta field4,x
    dey
    bne -

    lda .offset_table,y
    tax
    lda #>field2
    sta field2,x
    lda #>field3
    sta field3,x
    lda #>field4
    sta field4,x

    lda #$06
    sta field2+(<(field1_offs0-field1))
    lda #$05
    sta field3+(<(field1_offs0-field1))
    lda #$04
    sta field4+(<(field1_offs0-field1))

    lda #<field1_speed
    sta zp_temp0
    lda #>field1_speed
    sta zp_temp0+1

    lda #<field2_speed
    sta zp_temp1
    lda #>field2_speed
    sta zp_temp1+1

    lda #<field3_speed
    sta zp_temp2
    lda #>field3_speed
    sta zp_temp2+1

    lda #<field4_speed
    sta zp_temp3
    lda #>field4_speed
    sta zp_temp3+1

.outer_loop:
    lda #0

    ldx #0
.inner_loop:
    ldy #5
-
    lda .vorlage_field1,y
    sta (zp_temp0),y
    lda .vorlage_field2,y
    sta (zp_temp1),y
    lda .vorlage_field3,y
    sta (zp_temp2),y
    lda .vorlage_field4,y
    sta (zp_temp3),y
    dey
    bpl -

    jsr .sync_vorlage
    jsr .add_6

    inx
    cpx #39
    bne .inner_loop

    jsr .sync_vorlage

    inc .outer_loop+1
    lda .outer_loop+1
    cmp #25
    bne .outer_loop

    ldy #0
    lda #$60
    sta (zp_temp0),y
    sta (zp_temp1),y
    sta (zp_temp2),y
    sta (zp_temp3),y

    rts

.add_6:
    clc
    lda zp_temp0
    adc #6
    sta zp_temp0
    lda zp_temp0+1
    adc #0
    sta zp_temp0+1

    clc
    lda zp_temp1
    adc #6
    sta zp_temp1
    lda zp_temp1+1
    adc #0
    sta zp_temp1+1

    clc
    lda zp_temp2
    adc #6
    sta zp_temp2
    lda zp_temp2+1
    adc #0
    sta zp_temp2+1

    clc
    lda zp_temp3
    adc #6
    sta zp_temp3
    lda zp_temp3+1
    adc #0
    sta zp_temp3+1
    rts

.sync_vorlage:
    inc .vorlage_field1+1
    lda .vorlage_field1+1
    bne +
    inc .vorlage_field1+2
+
    inc .vorlage_field1+4
    lda .vorlage_field1+4
    bne +
    inc .vorlage_field1+5
+
    lda .vorlage_field1+1
    sta .vorlage_field2+1
    sta .vorlage_field3+1
    sta .vorlage_field4+1
    lda .vorlage_field1+4
    sta .vorlage_field2+4
    sta .vorlage_field3+4
    sta .vorlage_field4+4

    lda .vorlage_field1+2
    eor #$04
    sta .vorlage_field2+2
    eor #$0c
    sta .vorlage_field3+2
    eor #$04
    sta .vorlage_field4+2

    lda .vorlage_field1+5
    eor #$04
    sta .vorlage_field2+5
    eor #$0c
    sta .vorlage_field3+5
    eor #$04
    sta .vorlage_field4+5
    rts

.vorlage_field1:
    lda scr0+(0*40)+1
    sta scr0+(0*40)
.vorlage_field2:
    lda scr1+(0*40)+1
    sta scr1+(0*40)
.vorlage_field3:
    lda scr2+(0*40)+1
    sta scr2+(0*40)
.vorlage_field4:
    lda scr3+(0*40)+1
    sta scr3+(0*40)

.offset_table:
    !byte <(field1_offs1-field1), <(field1_offs2-field1)
    !byte <(field1_offs3-field1), <(field1_offs4-field1)
    !byte <(field1_offs5-field1), <(field1_offs6-field1)
    !byte <(field1_offs7-field1), <(field1_offs8-field1)
    !byte <(field1_offs9-field1), <(field1_offs10-field1)
    !byte <(field1_offs11-field1), <(field1_offs12-field1)
    !byte <(field1_offs13-field1), <(field1_offs14-field1)
    !byte <(field1_offs15-field1), <(field1_offs16-field1)
    !byte <(field1_offs17-field1), <(field1_offs18-field1)
    !byte <(field1_offs19-field1), <(field1_offs20-field1)
    !byte <(field1_offs21-field1), <(field1_offs22-field1)
    !byte <(field1_offs23-field1), <(field1_offs24-field1)
    !byte <(field1_offs25-field1), <(field1_offs26-field1)
.offset_table_end:
; ______________________________________________________________________
!zone IRQ0
!fi $100-(<*), 0
irq0:
    sta fw_savea
    stx fw_savex
    sty fw_savey

!if DEBUG = 1 {
    dec $d020
}

    ;~ lda $d016
    ;~ and #%11111000
d016_bits012 =*+1
    lda #0
    sta $d016

.xsav1 = *+1
    ldx #3
    lda .d018_table,x
    sta $d018
    lda .jsr_table,x
    sta jsr_mod
    sta jsr_mod1
    dex
    bpl +
    ldx #3
+
    stx .xsav1
    jsr blinking

    ldy textpointer+1
    jsr setsprites

    lda #irq1_line
    sta $d012

    lda #<irq1
    sta $fffe
    lda #>irq1
    sta $ffff

!if DEBUG = 1 {
    inc $d020
}
    asl $d019

    lda fw_savea
    ldx fw_savex
    ldy fw_savey
    rti

.d018_table:
    !byte $04, $14, $24, $34

.jsr_table:
    !byte >field4, >field1, >field2, >field3
; ______________________________________________________________________
!zone IRQ1
!fi $100-(<*), 0
irq1:
    sta fw_savea
    stx fw_savex
    sty fw_savey

!if DEBUG = 1 {
    dec $d020
}
    lda vic+1
    cmp #$60
    bne +

    lda textpointer+1
    clc
    adc #10
    tay
    jsr setsprites

    lda #20
    sta textaddval
+

repetitions:
    lda #$04
    bne ++
    ldy textpointer+1
    lda text,y
    cmp #$80
    bne +
    lda #10
    sta textaddval
+
    clc
    lda textpointer+1
textaddval = *+1
    adc #20
    sta textpointer+1
    clc
    lda textpointer+1
    adc #9
    tay
    lda text,y
    sta repetitions+1
++

    lda #0
    sta $d012

    lda #$1b
    sta $d011

    lda #1
    sta irq_bottom_ready

    lda #<fw_irq_addr
    sta $fffe
    lda #>fw_irq_addr
    sta $ffff

!if DEBUG = 1 {
    inc $d020
}
    asl $d019

    lda fw_savea
    ldx fw_savex
    ldy fw_savey
    rti
; ______________________________________________________________________
!fi $100-(<*), 0
; SPRITE TEXTS
; explanation:
; here you find the data for sprite texts;
; first byte: y-pos (if one line, set $80, two lines: upper $60 lower $a0)
; next 8 bytes: the 8 characters
; last byte: how often shall it be shown?
; if you want more/less chunks,
; --> Look for "XXX" to find a value which is to be increased/decreased by #10

text:
	!ct scr
;	!byte $80
;	!tx "@@@@@@@@"; would create an empty one-liner
;	!byte $01

	!byte $60
	!tx " z",31,"th@of"
	!byte $03

	!byte $a0
	!tx " october"
	!byte $03

	!byte $60
	!tx "@cheers@"
	!byte $03

	!byte $a0
	!tx "x",30,"zo",28,"g  "
	!byte $03

	!byte $80
	!tx "@@@@@@@@"
	!byte $02

	!byte $60
	!tx "achim",28,"  "
	!byte $03

	!byte $a0
	!tx "aw",29,"sm",28,"  "
	!byte $03

	!byte $60
	!tx "csixx   "
	!byte $03

	!byte $a0
	!tx "gi",30,"joe  "
	!byte $03

	!byte $60
	!tx " greyrat"
	!byte $03

	!byte $a0
	!tx "henning "
	!byte $03

	!byte $60
	!tx "  rqly  "
	!byte $03

	!byte $a0
	!tx "spider",30,"j"
	!byte $03

	!byte $60
	!tx "the@user"
	!byte $03

	!byte $a0
	!tx " thunder"
	!byte $03

	!byte $80
	!tx "theryk  "
	!byte $03

  !byte $80
	!tx "@@@@@@@@"
	!byte $03

	!byte $80
	!tx "m",28,"ayday",27
	!byte $04

	!byte $80
	!tx "@@@@@@@@"
	!byte $02

	!byte $60
text_fallen:
	!tx "fallen  "
	!byte $03

	!byte $a0
text_stars:
	!tx "stars   "
	!byte $03

; Table containing data for x dimension of sprite chars (to make it proportional font)
distance:
    !byte 28,28,28,28,28,28,28,28
    !byte 28,12,28,28,28,24,28,28
    !byte 28,28,28,28,28,28,28,24
    !byte 28,28,28,8,16,16,28,28
    !byte 00

field:    ; will be filled, important for random char/screen generator
    !fill 256,00
    !byte $00
coltab:   ; for fades
    !byte $0b,$0c,$0f,$01,$01 ;01,15,07;$0d,$03,07;01,07,$0d,$03,$0e,$05,$02

looptab:   ; hardcoded info for codegenerator
    !byte $ad,$01,$40,$8d,$00,$40

spocktext
    !scrxor $80, "loss oflife is tobe mourned"
    !scrxor $80, "but onlyif the lifewas wasted"
    !scrxor $80, "farewell        mr spock"
    !scrxor $80, "in memory ofleonard nimoy(1931-2015)"

spocktexttab; info how many characters are to be read and printed at which screen pos
    !byte 7,<spockscreen+(17*40),>spockscreen+(17*40)
    !byte 10,<spockscreen+(18*40),>spockscreen+(18*40)
    !byte 10,<spockscreen+(19*40),>spockscreen+(19*40)
    !byte 8,<spockscreen+(17*40)+32,>spockscreen+(17*40)+32
    !byte 11,<spockscreen+(18*40)+29,>spockscreen+(18*40)+29
    !byte 10,<spockscreen+(19*40)+30,>spockscreen+(19*40)+30

    !byte 8,<spockscreen+(22*40),>spockscreen+(22*40)
    !byte 8,<spockscreen+(23*40),>spockscreen+(23*40)
    !byte 8,<spockscreen+(24*40),>spockscreen+(24*40)
    !byte 12,<spockscreen+(22*40)+28,>spockscreen+(22*40)+28
    !byte 13,<spockscreen+(23*40)+27,>spockscreen+(23*40)+27
    !byte 11,<spockscreen+(24*40)+28,>spockscreen+(24*40)+28

; the PETSCII screen to be copied to Video RAM at $0400
spockdata:
	!bin "spockv003.prg",,2
	; this area will be overwritten by generated Scroll-Code right after being moved to $0400

; ______________________________________________________________________________
!zone SPEEDCODE_FIELD1
*= field1
field_vorlage_speedcode:
.xscrollval:
	lda #0
	sec
field1_offs0 =*+1
	sbc #$07
	and #$07
field1_offs1 =*+2
	sta .xscrollval+1
  sta d016_bits012
	bcc +
	rts
+
	jsr random
	tax
	lda field,x
field1_offs2 =*+2
	sta scr0+39+(0*40)
	inx
	lda field,x
field1_offs3 =*+2
	sta scr0+39+(5*40)
	inx
	lda field,x
field1_offs4 =*+2
	sta scr0+39+(10*40)
	inx
	lda field,x
field1_offs5 =*+2
	sta scr0+39+(15*40)
	inx
	lda field,x
field1_offs6 =*+2
	sta scr0+39+(20*40)

	jsr random
	tax
	lda field,x
field1_offs7 =*+2
	sta scr0+39+(1*40)
	inx
	lda field,x
field1_offs8 =*+2
	sta scr0+39+(6*40)
	inx
	lda field,x
field1_offs9 =*+2
	sta scr0+39+(11*40)
	inx
	lda field,x
field1_offs10 =*+2
	sta scr0+39+(16*40)
	inx
	lda field,x
field1_offs11 =*+2
	sta scr0+39+(21*40)

	jsr random
	tax
	lda field,x
field1_offs12 =*+2
	sta scr0+39+(2*40)
	inx
	lda field,x
field1_offs13 =*+2
	sta scr0+39+(7*40)
	inx
	lda field,x
field1_offs14 =*+2
	sta scr0+39+(12*40)
	inx
	lda field,x
field1_offs15 =*+2
	sta scr0+39+(17*40)
	inx
	lda field,x
field1_offs16 =*+2
	sta scr0+39+(22*40)

	jsr random
	tax
	lda field,x
field1_offs17 =*+2
	sta scr0+39+(3*40)
	inx
	lda field,x
field1_offs18 =*+2
	sta scr0+39+(8*40)
	inx
	lda field,x
field1_offs19 =*+2
	sta scr0+39+(13*40)
	inx
	lda field,x
field1_offs20 =*+2
	sta scr0+39+(18*40)
	inx
	lda field,x
field1_offs21 =*+2
	sta scr0+39+(23*40)

	jsr random
	tax
	lda field,x
field1_offs22 =*+2
	sta scr0+39+(4*40)
	inx
	lda field,x
field1_offs23 =*+2
	sta scr0+39+(9*40)
	inx
	lda field,x
field1_offs24 =*+2
	sta scr0+39+(14*40)
	inx
	lda field,x
field1_offs25 =*+2
	sta scr0+39+(19*40)
	inx
	lda field,x
field1_offs26 =*+2
	sta scr0+39+(24*40)

