!cpu 6510
DEBUG = 0
!src "colorcodes.asm"
; ______________________________________________________________________
enable                = $20
disable               = $2c

irq0_line             = $00
irq1_line             = $f9

sprmulti0             = $00
sprmulti1             = $07
sprstarxstart         = $ad
sprstarystart         = $20
sprtextxstart         = $b0
sprtextystart         = $30

star_anim_speed       = $02
text_fade_speed       = $03
text_wait_speed       = $4f

bg_col0               = blue

sid                   = $d400

; ____________ ZEROPAGE ADRESSES

d015_value_top        = $05
irq_bottom_ready      = d015_value_top+1
irq_top_ready         = irq_bottom_ready+1
d015_value_bottom     = irq_top_ready+1

; ____________ RAM ADRESSES

bank0                 = $0000
vidmem0               = bank0+$0400
spritept0             = vidmem0+$3f8

bank1                 = $8000
vidmem1               = bank1+$0400
spritedata1           = bank1+$2000
spritept1             = vidmem1+$3f8
; ______________________________________________ INCLUDES
!src "../../bin/framework/frameworksymbols.inc"
; ______________________________________________________________________
!zone FADE_IN
*= $3600
code_start:
!if RELEASE = 0 {
    sei
    lda #$7f
    sta $dc0d
    sta $dd0d
    lda $dc0d
    lda $dd0d

    lda #$35
    sta $01
}
    lda $d020
    sta border_val

    lda #$00
    sta bank1+$3fff
    sta d015_value_top

    lda #$20
    ldx #>vidmem1
    ldy #>vidmem1+$400
    jsr helper_memfill          ; and also vidmem1

    ldx #$00
--
    lda random_tab,x            ; random bla
    tay
!if DEBUG = 1 {
    lda #161
} else {
    lda #160
}
    sta vidmem0+$000,y
    sta vidmem0+$100,y
    sta vidmem0+$200,y
    sta vidmem0+$300,y
border_val =*+1
    lda #$00
    sta $d800+$000,y
    sta $d800+$100,y
    sta $d800+$200,y
    sta $d800+$300,y
    jsr wait_bottom
    inx
    bne --

    lda #$0b
    sta $d011

    ldy #$7f
-   jsr wait_top
    lda #bg_col0
    sta $d020
.mod0 =*+1
    lda #$02
    cmp $d012
    bne *-3
    ldx #9
    dex
    bpl *-1
    lda border_val
    sta $d020
    inc .mod0
    inc .mod0
    dey
    bne -

    jsr wait_top
    lda #bg_col0
    sta $d020
    bit $d011
    bpl *-3
    ldx #9
    dex
    bpl *-1
    lda border_val
    sta $d020
    ldy #$17
-   jsr wait_top
    lda #bg_col0
    sta $d020
    bit $d011
    bpl *-3
.mod1 =*+1
    lda #$02
    cmp $d012
    bne *-3
    ldx #9
    dex
    bpl *-1
    lda border_val
    sta $d020
    inc .mod1
    inc .mod1
    dey
    bne -

    jsr wait_top
    lda #bg_col0
    sta $d020
    sta $d021
!if DEBUG = 1 {
    lda #pink
    sta $d020
}
    ldx #0
    lda #bg_col0
-   sta $d800+$000,x
    sta $d800+$100,x
    sta $d800+$200,x
    sta $d800+$2e8,x
    inx
    bne -
    jsr wait_top
; ______________________________________________________________________
!zone MAIN
irq_setup:
    lda #$01
    sta $d01a

    lda #irq1_line
    sta $d012

    lda #$1b
    sta $d011

    lda #<irq1
    sta $fffe
    lda #>irq1
    sta $ffff

    lda #<nmi
    sta $fffa
    lda #>nmi
    sta $fffb

    asl $d019

    cli

    lda #enable
    sta enable_sprites

    lda #$01
    sta d015_value_bottom

    lda #$ea
    sta sprites_anim_star

    jsr wait_irq_top
    lda #<!(bank1/$4000) & 3
    sta $dd00

    ldy #($13*2)
-
    jsr wait_irq_bottom
    dec sprites_ypos_tab+0
    dey
    bne -

    lda #$01
    sta d015_value_top

    ldy #$70
-
    jsr wait_irq_top
    dec sprites_ypos_tab+0
    dey
    bne -

    lda #$ff
    sta d015_value_top

    lda #enable
    sta enable_sprites_fade_in

wait_last_text_line =*+1
-   lda #0
    beq -

    ldx #3
--
    ldy #8
-   jsr wait_irq_top
    dey
    bpl -

    lda bg_fade_table,x
    sta $d020
    sta $d021

    dex
    bpl --

    ldx #$00
--
    jsr wait_irq_bottom
    lda random_tab,x            ; random bla
    tay
    lda source_screen+$000,y
    sta vidmem0+$000,y
    sta vidmem1+$000,y
    lda source_screen+$100,y
    sta vidmem0+$100,y
    sta vidmem1+$100,y
    lda source_screen+$200,y
    sta vidmem0+$200,y
    sta vidmem1+$200,y
    lda source_screen+$300,y
    sta vidmem0+$300,y
    sta vidmem1+$300,y
    lda source_colram+$000,y
    sta $d800+$000,y
    lda source_colram+$100,y
    sta $d800+$100,y
    lda source_colram+$200,y
    sta $d800+$200,y
    lda source_colram+$300,y
    sta $d800+$300,y
    jsr sprites_star_down
    inx
    bne --

    jsr wait_irq_top
    lda #<!(bank0/$4000) & 3
    sta $dd00

    lda #$1f
    sta fw_d011_value
-
    jsr wait_irq_bottom
    dec rauschen_volume
    lda rauschen_volume
    bpl -

    sei
!if RELEASE = 1 {
    rts
    !byte 0, 0
} else {
    jmp *
}
; ______________________________________________________________________
!zone WAIT_ROUTINES
wait_bottom:
    lda #$ff
    cmp $d012
    bne *-3
    rts
wait_top:
    bit $d011
    bpl *-3
    bit $d011
    bmi *-3
    rts
wait_irq_top:
    lda #0
    sta irq_top_ready
-
    lda irq_top_ready
    beq -
    rts
wait_irq_bottom:
    lda #0
    sta irq_bottom_ready
-
    lda irq_bottom_ready
    beq -
    rts
; ______________________________________________________________________
!zone SPRITES
sprites_setup:
    ldx #7
    ldy #$0e
-                               ; setup
    lda sprites_xpos_tab,x      ; x-positions
    sta $d000,y
    lda sprites_ypos_tab,x      ; y-positions
    sta $d001,y                 ; and
    lda sprites_color_tab,x     ; colors
    sta $d027,x
    lda sprites_pointer_tab,x
    sta spritept1,x
    dey
    dey
    dex
    bpl -

    lda #sprmulti0              ; setup multicolors
    sta $d025
    lda #sprmulti1
    sta $d026

    lda #0                      ; setup expand registers
    sta $d01d
    sta $d017

    lda #$00                    ; set multicolor mode
    sta $d01c

    ldx #7
    lda #$00
-   ora sprites_d010_tab,x      ; set $d010
    dex
    bpl -
    sta $d010

    rts

sprites_xpos_tab:
    !byte sprstarxstart+(0*24)
    !byte sprtextxstart+(0*24)-150
    !byte sprtextxstart+(1*24)-150
    !byte sprtextxstart+(2*24)-150
    !byte sprtextxstart+(3*24)-150
    !byte sprtextxstart+(4*24)-150
    !byte sprtextxstart+(5*24)-150
    !byte sprtextxstart+(6*24)-150

sprites_ypos_tab:
    !byte sprstarystart
    !byte sprtextystart
    !byte sprtextystart
    !byte sprtextystart
    !byte sprtextystart
    !byte sprtextystart
    !byte sprtextystart
    !byte sprtextystart

sprites_color_tab:
    !byte yellow
    !byte blue
    !byte blue
    !byte blue
    !byte blue
    !byte blue
    !byte blue
    !byte blue

sprites_d010_tab:
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000

sprites_pointer_tab:
    !byte <(((spritedata1-bank1)/$40)+0)
    !byte <(((spritedata1-bank1)/$40)+6)
    !byte <(((spritedata1-bank1)/$40)+7)
    !byte <(((spritedata1-bank1)/$40)+8)
    !byte <(((spritedata1-bank1)/$40)+9)
    !byte <(((spritedata1-bank1)/$40)+10)
    !byte <(((spritedata1-bank1)/$40)+11)
    !byte <(((spritedata1-bank1)/$40)+12)

; ______________________________________________________________________
sprites_anim_star:
    rts
.ct0 =*+1
    lda #star_anim_speed
    beq +
    dec .ct0
    rts
+
    lda #star_anim_speed
    sta .ct0
    inc sprites_pointer_tab+0
    lda sprites_pointer_tab+0
    cmp #<(((spritedata1-bank1)/$40)+6)
    bne +
    lda #<(((spritedata1-bank1)/$40))
    sta sprites_pointer_tab+0
+
    rts
; ______________________________________________________________________
sprites_star_down:
    nop

    inc sprites_ypos_tab
    lda sprites_ypos_tab
    beq .linezero
    cmp #sprstarystart
    beq .lineend
    rts
.linezero:
    lda #$00
    sta d015_value_top
    lda #$01
    sta d015_value_bottom
    rts
.lineend:
    lda #$00
    sta d015_value_bottom
    lda #$60
    sta sprites_star_down
    rts

; ______________________________________________________________________
sprites_fade_in:
.ct1 =*+1
    lda #text_fade_speed
    beq +
    dec .ct1
    rts
+
    lda #text_fade_speed
    sta .ct1

    ldx #6
.ysav0 =*+1
    ldy #0
    cpy #$04
    beq +
    lda sprites_fade_tab,y
-
    sta sprites_color_tab+1,x
    dex
    bpl -

    inc .ysav0
    rts
+
    lda #0
    sta .ysav0
-
.sprites_color_tab_pointer =*+1
    lda sprites_fade_dest,x
    sta sprites_color_tab+1,x
    dex
    bpl -

    clc
    lda .sprites_color_tab_pointer
    adc #7
    sta .sprites_color_tab_pointer
    lda .sprites_color_tab_pointer+1
    adc #0
    sta .sprites_color_tab_pointer+1

    lda #disable
    sta enable_sprites_fade_in
    lda #enable
    sta enable_sprites_wait
    rts

sprites_fade_out:
.ct2 =*+1
    lda #text_fade_speed
    beq +
    dec .ct2
    rts
+
    lda #text_fade_speed
    sta .ct2

    ldx #6
.ysav1 =*+1
    ldy #$03
    cpy #$ff
    beq +
    lda sprites_fade_tab,y
-
    sta sprites_color_tab+1,x
    dex
    bpl -

    dec .ysav1
    rts
+
    lda #$03
    sta .ysav1

    lda #disable
    sta enable_sprites_fade_out
    lda #enable
    sta enable_sprites_wait
    rts

sprite_fade_wait:
.ct3 =*+1
    lda #text_wait_speed
    beq +
    dec .ct3
    rts
+
    lda #text_wait_speed
    sta .ct3

.mod1 =*+1
    lda #0
    beq +
    eor #$08
    sta .mod1

    ldx #6
-
.sprites_pointer_pointer =*+1
    lda sprites_pointer_dest,x
    sta sprites_pointer_tab+1,x
.sprites_xpos_pointer =*+1
    lda sprites_xpos_dest,x
    sta sprites_xpos_tab+1,x
.sprites_d010_pointer =*+1
    lda sprites_d010_dest,x
    sta sprites_d010_tab+1,x
    dex
    bpl -

    clc
    lda .sprites_pointer_pointer
    adc #7
    sta .sprites_pointer_pointer
    lda .sprites_pointer_pointer+1
    adc #0
    sta .sprites_pointer_pointer+1

    clc
    lda .sprites_xpos_pointer
    adc #7
    sta .sprites_xpos_pointer
    lda .sprites_xpos_pointer+1
    adc #0
    sta .sprites_xpos_pointer+1

    clc
    lda .sprites_d010_pointer
    adc #7
    sta .sprites_d010_pointer
    lda .sprites_d010_pointer+1
    adc #0
    sta .sprites_d010_pointer+1

    lda #enable
    sta enable_sprites_fade_in
    jmp .exit
+
    eor #$08
    sta .mod1

    lda .sprites_pointer_pointer
    cmp #<sprites_pointer_dest_end
    bne +
    lda .sprites_pointer_pointer+1
    cmp #>sprites_pointer_dest_end
    bne +
    lda #1
    sta wait_last_text_line
    lda #$38                    ; SEC
    sta rauschen_clc
    lda #$e9                    ; SBC
    sta rauschen_adc0
    sta rauschen_adc1
    lda #$05
    sta rauschen_adc0+1
    jmp .exit
+
    lda #enable
    sta enable_sprites_fade_out
.exit:
    lda #disable
    sta enable_sprites_wait
    rts
sprites_fade_tab:
    !byte blue, purple, light_blue, light_grey
; ______________________________________________________________________
!zone IRQs
irq0:
    sta fw_savea
    stx fw_savex
    sty fw_savey
!if DEBUG = 1 {
    dec $d020
}

    lda d015_value_top
    sta $d015

enable_sprites:
    bit sprites_setup
    jsr sprites_anim_star

    lda #$1f
    sta $d011

    lda #<irq1
    sta $fffe
    lda #>irq1
    sta $ffff

    lda #irq1_line
    sta $d012

    lda #1
    sta irq_top_ready
!if DEBUG = 1 {
    inc $d020
}
    jmp irq_exit

irq1:
    sta fw_savea
    stx fw_savex
    sty fw_savey

    lda #$17
    sta $d011

    lda d015_value_bottom
    sta $d015

!if DEBUG = 1 {
    dec $d020
}

enable_sprites_wait:
    bit sprite_fade_wait
enable_sprites_fade_in:
    bit sprites_fade_in
enable_sprites_fade_out:
    bit sprites_fade_out

    jsr rauschen

    lda #<irq0
    sta $fffe
    lda #>irq0
    sta $ffff

    lda #irq0_line
    sta $d012

    lda #1
    sta irq_bottom_ready

!if DEBUG = 1 {
    inc $d020
}
irq_exit:
    asl $d019

    lda fw_savea
    ldx fw_savex
    ldy fw_savey
nmi:
    rti

; ==============================================================================
; memfill
; ------------+-----------------------------------------------------------------
; depends on: | -
; ------------+-----------------------------------------------------------------
; uses:       | A, X, Y
; ------------+-----------------------------------------------------------------
; preserves:  | A
; ------------+---+-------------------------------------------------------------
; input:      | A | fill value
;             | X | highbyte fill startaddress
;             | Y | highbyte fill endaddress
; ------------+---+-------------------------------------------------------------
; output:     | - |
; ------------+---+-------------------------------------------------------------
!zone MEMFILL {
helper_memfill:
    stx .from_hi
    sty .to_hi
.loop:
    ldx #0
-
.from_hi =*+2
    sta $0000,x
    inx
    bne -

    inc .from_hi
    ldy .from_hi
.to_hi =*+1
    cpy #0
    bne .loop
    rts
}
; ______________________________________________________________________
rauschen:
.lo =*+1
    lda #$40
    sta sid+0
.hi =*+1
    lda #$01
    sta sid+1

    lda #$04
    sta sid+5
    lda #$ff
    sta sid+6

    lda #$81
    sta sid+4

    lda #$00
    sta sid+21
.filter =*+1
    lda #$20
    sta sid+22

    lda #$f1
    sta sid+23

    lda #%00100000
rauschen_volume =*+1
    ora #$0f
    sta sid+24
rauschen_clc:
    clc
    lda .lo
rauschen_adc0:
    adc #1
    sta .lo
    lda .hi
rauschen_adc1:
    adc #0
    sta .hi

    lda .filter
    cmp #$04
    beq .eordir
    cmp #$38
    beq .eordir
.filter_dir:
    dec .filter
    rts
.eordir:
    lda .filter_dir
    eor #($EE XOR $CE)
    sta .filter_dir
    jmp .filter_dir
*= $3ffd
    bit $0000
; ______________________________________________________________________
!zone DATA
*= $4000
source_screen:
    !bin "../fstarscroll/resources/sky-01.c64",1000,$62
source_colram:
    !bin "../fstarscroll/resources/sky-01.c64",1000,$44a

random_tab:
    !byte 208, 029, 189, 225, 145, 054, 196, 045
    !byte 091, 136, 126, 165, 236, 103, 128, 106
    !byte 019, 217, 026, 174, 032, 021, 245, 043
    !byte 147, 059, 134, 255, 206, 101, 068, 241
    !byte 016, 015, 035, 067, 239, 024, 227, 011
    !byte 040, 042, 215, 117, 139, 052, 100, 137
    !byte 243, 231, 049, 232, 234, 164, 074, 214
    !byte 194, 072, 150, 030, 143, 069, 046, 051
    !byte 033, 114, 082, 080, 075, 183, 003, 056
    !byte 159, 066, 177, 124, 209, 009, 249, 154
    !byte 031, 093, 008, 077, 251, 004, 220, 195
    !byte 211, 250, 235, 017, 071, 120, 237, 138
    !byte 254, 070, 109, 104, 187, 125, 155, 110
    !byte 179, 127, 204, 170, 178, 006, 153, 201
    !byte 229, 212, 146, 240, 084, 047, 028, 228
    !byte 115, 092, 007, 148, 210, 224, 197, 144
    !byte 246, 090, 089, 062, 001, 161, 121, 184
    !byte 157, 172, 087, 050, 002, 005, 058, 198
    !byte 036, 149, 108, 168, 248, 132, 173, 041
    !byte 095, 202, 158, 186, 166, 130, 116, 238
    !byte 203, 111, 076, 044, 020, 140, 012, 023
    !byte 105, 160, 099, 112, 247, 022, 083, 034
    !byte 135, 025, 244, 096, 185, 060, 053, 102
    !byte 061, 167, 233, 057, 131, 119, 190, 085
    !byte 223, 252, 182, 129, 107, 226, 013, 253
    !byte 133, 010, 200, 169, 063, 181, 175, 221
    !byte 207, 171, 037, 141, 205, 098, 018, 055
    !byte 113, 027, 222, 219, 065, 152, 156, 039
    !byte 123, 142, 038, 081, 199, 162, 216, 078
    !byte 192, 118, 191, 014, 094, 230, 218, 073
    !byte 048, 122, 088, 242, 188, 176, 086, 163
    !byte 000, 180, 213, 079, 151, 064, 097, 193

sprites_fade_dest:
    !byte $01, $01, $01, $01, $01, $07, $07
    !byte $01, $01, $01, $01, $01, $07, $07
    !byte $01, $01, $01, $01, $01, $07, $07
    !byte $01, $01, $01, $01, $01, $07, $07
    !byte $01, $01, $01, $07, $07, $07, $07
    !byte $01, $01, $01, $01, $01, $01, $01
    !byte $01, $01, $01, $01, $01, $01, $01
    !byte $01, $01, $01, $07, $07, $07, $07

sprites_pointer_dest:
    !byte <(((spritedata1-bank1)/$40)+13)
    !byte <(((spritedata1-bank1)/$40)+14)
    !byte <(((spritedata1-bank1)/$40)+15)
    !byte <(((spritedata1-bank1)/$40)+16)
    !byte <(((spritedata1-bank1)/$40)+17)
    !byte <(((spritedata1-bank1)/$40)+18)
    !byte <(((spritedata1-bank1)/$40)+58)

    !byte <(((spritedata1-bank1)/$40)+19)
    !byte <(((spritedata1-bank1)/$40)+20)
    !byte <(((spritedata1-bank1)/$40)+21)
    !byte <(((spritedata1-bank1)/$40)+22)
    !byte <(((spritedata1-bank1)/$40)+23)
    !byte <(((spritedata1-bank1)/$40)+24)
    !byte <(((spritedata1-bank1)/$40)+25)

    !byte <(((spritedata1-bank1)/$40)+26)
    !byte <(((spritedata1-bank1)/$40)+27)
    !byte <(((spritedata1-bank1)/$40)+28)
    !byte <(((spritedata1-bank1)/$40)+29)
    !byte <(((spritedata1-bank1)/$40)+30)
    !byte <(((spritedata1-bank1)/$40)+31)
    !byte <(((spritedata1-bank1)/$40)+32)

    !byte <(((spritedata1-bank1)/$40)+33)
    !byte <(((spritedata1-bank1)/$40)+34)
    !byte <(((spritedata1-bank1)/$40)+35)
    !byte <(((spritedata1-bank1)/$40)+36)
    !byte <(((spritedata1-bank1)/$40)+37)
    !byte <(((spritedata1-bank1)/$40)+38)
    !byte <(((spritedata1-bank1)/$40)+58)

    !byte <(((spritedata1-bank1)/$40)+39)
    !byte <(((spritedata1-bank1)/$40)+40)
    !byte <(((spritedata1-bank1)/$40)+41)
    !byte <(((spritedata1-bank1)/$40)+42)
    !byte <(((spritedata1-bank1)/$40)+43)
    !byte <(((spritedata1-bank1)/$40)+44)
    !byte <(((spritedata1-bank1)/$40)+45)

    !byte <(((spritedata1-bank1)/$40)+46)
    !byte <(((spritedata1-bank1)/$40)+47)
    !byte <(((spritedata1-bank1)/$40)+48)
    !byte <(((spritedata1-bank1)/$40)+49)
    !byte <(((spritedata1-bank1)/$40)+50)
    !byte <(((spritedata1-bank1)/$40)+51)
    !byte <(((spritedata1-bank1)/$40)+58)

    !byte <(((spritedata1-bank1)/$40)+52)
    !byte <(((spritedata1-bank1)/$40)+53)
    !byte <(((spritedata1-bank1)/$40)+54)
    !byte <(((spritedata1-bank1)/$40)+55)
    !byte <(((spritedata1-bank1)/$40)+56)
    !byte <(((spritedata1-bank1)/$40)+57)
    !byte <(((spritedata1-bank1)/$40)+58)
sprites_pointer_dest_end:

sprites_xpos_dest:
    !byte sprtextxstart+(0*24)+26
    !byte sprtextxstart+(1*24)+26
    !byte sprtextxstart+(2*24)+26
    !byte <sprtextxstart+(3*24)+26
    !byte <sprtextxstart+(4*24)+26
    !byte <sprtextxstart+(5*24)+26
    !byte <sprtextxstart+(6*24)+26      ; working hard ...

    !byte sprtextxstart+(0*24)-150
    !byte sprtextxstart+(1*24)-150
    !byte sprtextxstart+(2*24)-150
    !byte sprtextxstart+(3*24)-150
    !byte sprtextxstart+(4*24)-150
    !byte sprtextxstart+(5*24)-150
    !byte sprtextxstart+(6*24)-150      ; making friends ...

    !byte sprtextxstart+(0*24)+8
    !byte sprtextxstart+(1*24)+8
    !byte sprtextxstart+(2*24)+8
    !byte <sprtextxstart+(3*24)+8
    !byte <sprtextxstart+(4*24)+8
    !byte <sprtextxstart+(5*24)+8
    !byte <sprtextxstart+(6*24)+8       ; to rise to the top

    !byte sprtextxstart+(0*24)-150
    !byte sprtextxstart+(1*24)-150
    !byte sprtextxstart+(2*24)-150
    !byte sprtextxstart+(3*24)-150
    !byte sprtextxstart+(4*24)-150
    !byte sprtextxstart+(5*24)-150
    !byte sprtextxstart+(6*24)-150      ; messing up ...

    !byte sprtextxstart+(0*24)+8
    !byte sprtextxstart+(1*24)+8
    !byte sprtextxstart+(2*24)+8
    !byte <sprtextxstart+(3*24)+8
    !byte <sprtextxstart+(4*24)+8
    !byte <sprtextxstart+(5*24)+8
    !byte <sprtextxstart+(6*24)+8       ; pcs stuff ...

    !byte sprtextxstart+(0*24)-150
    !byte sprtextxstart+(1*24)-150
    !byte sprtextxstart+(2*24)-150
    !byte sprtextxstart+(3*24)-150
    !byte sprtextxstart+(4*24)-150
    !byte sprtextxstart+(5*24)-150
    !byte sprtextxstart+(6*24)-150

    !byte sprtextxstart+(0*24)+28
    !byte sprtextxstart+(1*24)+28
    !byte sprtextxstart+(2*24)+28
    !byte <sprtextxstart+(3*24)+28
    !byte <sprtextxstart+(4*24)+28
    !byte <sprtextxstart+(5*24)+28
    !byte <sprtextxstart+(6*24)+28

    !byte sprtextxstart+(0*24)-150
    !byte sprtextxstart+(1*24)-150
    !byte sprtextxstart+(2*24)-150
    !byte sprtextxstart+(3*24)-150
    !byte sprtextxstart+(4*24)-150
    !byte sprtextxstart+(5*24)-150
    !byte sprtextxstart+(6*24)-150

sprites_d010_dest:
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00010000
    !byte %00100000
    !byte %01000000
    !byte %10000000

    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000

    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00010000
    !byte %00100000
    !byte %01000000
    !byte %10000000

    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000

    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00010000
    !byte %00100000
    !byte %01000000
    !byte %10000000

    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000

    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00010000
    !byte %00100000
    !byte %01000000
    !byte %10000000

    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
    !byte %00000000
bg_fade_table:
    !byte black, dark_grey, grey, purple

!if DEBUG = 1 {
*= vidmem1
    !fi 1000, $aa
}
*= spritedata1
source_sprites:
    !bin "sprite-set_rotate-star_6frames.bin"
    !bin "star-poem-01-reduced.bin"
    !fi $40, $00
source_sprites_end:
